package org.jboss.jsr299.tck.tests.event.resolve.binding;

import java.util.Set;

import javax.event.Observer;

import org.hibernate.tck.annotations.SpecAssertion;
import org.jboss.jsr299.tck.AbstractJSR299Test;
import org.jboss.testharness.impl.packaging.Artifact;
import org.testng.annotations.Test;

@Artifact
public class ResolvingChecksBindingTypeTest extends AbstractJSR299Test
{
   public static class AnEventType
   {
   }

   public static class AnObserver implements Observer<AnEventType>
   {
      public boolean wasNotified = false;

      public void notify(AnEventType event)
      {
         wasNotified = true;
      }
   }

   @Test(groups = { "events" })
   @SpecAssertion(section = "7.7", id = "g")
   public void testResolvingChecksBindingTypes()
   {
      AnObserver observer = new AnObserver();
      AnObserver anotherObserver = new AnObserver();
      getCurrentManager().addObserver(observer, AnEventType.class, new BindingTypeABinding());
      getCurrentManager().addObserver(anotherObserver, AnEventType.class, new BindingTypeBBinding());
      Set<Observer<AnEventType>> resolvedObservers = getCurrentManager().resolveObservers(new AnEventType(), new BindingTypeABinding());
      assert resolvedObservers.size() == 1;
   }


}
